'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SC = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  display: flex;\n  flex-direction: ', ';\n  align-items: center;\n  justify-content: center;\n'], ['\n  display: flex;\n  flex-direction: ', ';\n  align-items: center;\n  justify-content: center;\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  position: relative;\n  display: flex;\n  justify-content: center;\n'], ['\n  position: relative;\n  display: flex;\n  justify-content: center;\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  background-size: auto 90%;\n  min-width: 5rem;\n  min-height: 8rem;\n'], ['\n  background-size: auto 90%;\n  min-width: 5rem;\n  min-height: 8rem;\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n  position: relative;\n  display: flex;\n  flex-direction: ', ';\n'], ['\n  position: relative;\n  display: flex;\n  flex-direction: ', ';\n']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(['\n  width: ', ';\n  overflow-x: hidden;\n  overflow-y: hidden;\n  display: flex;\n  align-items: center;\n'], ['\n  width: ', ';\n  overflow-x: hidden;\n  overflow-y: hidden;\n  display: flex;\n  align-items: center;\n']),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(['\n  margin-right: ', ';\n'], ['\n  margin-right: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _SVGDir = require('./svg/SVGDir');

var _SVGDir2 = _interopRequireDefault(_SVGDir);

var _reactMediumImageZoom = require('react-medium-image-zoom');

var _reactMediumImageZoom2 = _interopRequireDefault(_reactMediumImageZoom);

var _OutsideClickListener = require('./OutsideClickListener');

var _Accordion = require('./Accordion');

var _Accordion2 = _interopRequireDefault(_Accordion);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _defaultStyles = require('./defaultStyles');

var _reactSwipeable = require('react-swipeable');

var _KBListener = require('./KBListener');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NEXT = 'NEXT';
var PREV = 'PREV';
var GOTO = 'GOTO';

var initialState = { pos: 0, sliding: false, dir: NEXT };

var Container = _styledComponents2.default.div.attrs(function (_ref) {
  var style = _ref.style;
  return {
    style: style,
    className: 'imageviewer__container'
  };
})(_templateObject, function (_ref2) {
  var layout = _ref2.layout;
  return layout === 'vertical' ? 'row' : 'column';
});
var MainFrame = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: 'imageviewer__mainframe'
  };
})(_templateObject2);

var PreviewButton = (0, _styledComponents2.default)(_Button2.default).attrs(function (_) {
  return {
    className: 'imageviewer__previewbutton'
  };
})(_templateObject3);

var PreviewFrame = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: 'imageviewer__previewframe'
  };
})(_templateObject4, function (_ref3) {
  var layout = _ref3.layout;
  return layout === 'vertical' ? 'column' : 'row';
});

var PreviewAccordion = _styledComponents2.default.div.attrs(function (_) {
  return {
    className: 'imageviewer__previewaccordion'
  };
})(function (_ref4) {
  var layout = _ref4.layout,
      previewImageWidth = _ref4.previewImageWidth,
      mainImageWidth = _ref4.mainImageWidth,
      previewImageHeight = _ref4.previewImageHeight,
      mainImageMaxHeight = _ref4.mainImageMaxHeight,
      srcsLength = _ref4.srcsLength;
  return {
    overflow: 'hidden',
    display: 'flex',
    flexDirection: layout === 'vertical' ? 'column' : 'row',
    width: layout === 'vertical' ? 'auto' : srcsLength * previewImageWidth > mainImageWidth ? mainImageWidth : srcsLength * previewImageWidth,
    height: layout === 'vertical' ? srcsLength * previewImageHeight > mainImageMaxHeight ? mainImageMaxHeight : srcsLength * previewImageHeight : 'auto'
  };
});

var MainImageFrame = _styledComponents2.default.div(_templateObject5, function (_ref5) {
  var width = _ref5.width;
  return width;
});
var MainImage = _styledComponents2.default.div(_templateObject6, function (_ref6) {
  var imageMargin = _ref6.imageMargin;
  return imageMargin;
});

var sharedLargeNavButtonStyle = {
  position: 'absolute',
  top: 0,
  padding: 0,
  zIndex: 1
};

var LargeNavButton = (0, _styledComponents2.default)(_Button2.default)(function (_ref7) {
  var layout = _ref7.layout,
      disableDiscreteNavButtons = _ref7.disableDiscreteNavButtons,
      previewImageHeight = _ref7.previewImageHeight,
      mainImageMaxHeight = _ref7.mainImageMaxHeight,
      previewImageWidth = _ref7.previewImageWidth,
      mainImageWidth = _ref7.mainImageWidth,
      dir = _ref7.dir,
      srcsLength = _ref7.srcsLength;
  return layout === 'vertical' ? (0, _extends3.default)({}, sharedLargeNavButtonStyle, {
    display: disableDiscreteNavButtons ? 'none' : srcsLength * previewImageHeight > mainImageMaxHeight ? 'flex' : 'none',
    top: dir === PREV ? -30 : 'auto',
    bottom: dir === NEXT ? -30 : 'auto',
    width: '100%',
    height: 30
  }) : (0, _extends3.default)({}, sharedLargeNavButtonStyle, {
    display: disableDiscreteNavButtons ? 'none' : srcsLength * previewImageWidth > mainImageWidth ? 'flex' : 'none',
    left: dir === PREV ? -30 : 'auto',
    right: dir === NEXT ? -30 : 'auto',
    height: '100%',
    width: 30
  });
});

var sharedSmallNavButtonStyles = {
  height: '2.5rem',
  width: '2.5rem',
  margin: '0 1.75rem',
  border: '1px solid white',
  padding: '1rem',
  zIndex: 1
};

var SmallNavButton = (0, _styledComponents2.default)(_Button2.default)(function (_ref8) {
  var layout = _ref8.layout,
      disableDiscreteNavButtons = _ref8.disableDiscreteNavButtons,
      previewImageHeight = _ref8.previewImageHeight,
      mainImageMaxHeight = _ref8.mainImageMaxHeight,
      previewImageWidth = _ref8.previewImageWidth,
      mainImageWidth = _ref8.mainImageWidth,
      srcsLength = _ref8.srcsLength;
  return layout === 'vertical' ? (0, _extends3.default)({}, sharedSmallNavButtonStyles, {
    display: disableDiscreteNavButtons ? 'none' : srcsLength * previewImageHeight > mainImageMaxHeight ? 'none' : 'flex'
  }) : (0, _extends3.default)({}, sharedSmallNavButtonStyles, {
    display: disableDiscreteNavButtons ? 'none' : srcsLength * previewImageWidth > mainImageWidth ? 'none' : 'flex'
  });
});

var SC = exports.SC = {
  Container: Container,
  MainFrame: MainFrame,
  PreviewButton: PreviewButton,
  PreviewFrame: PreviewFrame,
  PreviewAccordion: PreviewAccordion,
  MainImageFrame: MainImageFrame,
  MainImage: MainImage,
  SmallNavButton: SmallNavButton,
  LargeNavButton: LargeNavButton
};

var ImageViewer = function ImageViewer(_ref9) {
  var _ref9$debug = _ref9.debug,
      debug = _ref9$debug === undefined ? false : _ref9$debug,
      _ref9$imageMargin = _ref9.imageMargin,
      imageMargin = _ref9$imageMargin === undefined ? 30 : _ref9$imageMargin,
      _ref9$srcs = _ref9.srcs,
      srcs = _ref9$srcs === undefined ? (0, _from2.default)({ length: 8 }, function (_, i) {
    return 'https://loremflickr.com/210/300?random=' + i;
  }) : _ref9$srcs,
      disableDiscreteNavButtons = _ref9.disableDiscreteNavButtons,
      accordionProps = _ref9.accordionProps,
      layout = _ref9.layout,
      className = _ref9.className,
      style = _ref9.style,
      onClick = _ref9.onClick,
      renderMidArea = _ref9.renderMidArea,
      renderOption = _ref9.renderOption,
      renderOptions = _ref9.renderOptions,
      _ref9$zoomedInImagePr = _ref9.zoomedInImageProps,
      zoomedInImageProps = _ref9$zoomedInImagePr === undefined ? {} : _ref9$zoomedInImagePr,
      _ref9$unzoomedImagePr = _ref9.unzoomedImageProps,
      unzoomedImageProps = _ref9$unzoomedImagePr === undefined ? {
    style: {
      width: '30rem',
      overflowX: 'hidden',
      overflowY: 'hidden'
    }
  } : _ref9$unzoomedImagePr,
      _ref9$cssImageUnzoome = _ref9.cssImageUnzoomedClass,
      cssImageUnzoomedClass = _ref9$cssImageUnzoome === undefined ? 'imageviewer__image--unzoomed' : _ref9$cssImageUnzoome,
      _ref9$cssImageZoomedI = _ref9.cssImageZoomedInClass,
      cssImageZoomedInClass = _ref9$cssImageZoomedI === undefined ? 'imageviewer__image--zoomed-in' : _ref9$cssImageZoomedI;

  var slide = function () {
    var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dir) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              dispatch({ type: dir, numItems: numItems });
              _context.next = 3;
              return setTimeout(function () {
                dispatch({ type: 'stopSliding' });
              }, 1000);

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function slide(_x) {
      return _ref10.apply(this, arguments);
    };
  }();

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray3.default)(_useState, 2),
      isComponentActive = _useState2[0],
      setIsComponentActive = _useState2[1];

  var reducer = function reducer(state, _ref11) {
    var type = _ref11.type,
        numItems = _ref11.numItems,
        pos = _ref11.pos;

    switch (type) {
      case 'reset':
        return initialState;
      case PREV:
        return (0, _extends3.default)({}, state, {
          dir: PREV,
          sliding: true,
          pos: state.pos === 0 ? numItems - 1 : state.pos - 1
        });
      case NEXT:
        return (0, _extends3.default)({}, state, {
          dir: NEXT,
          sliding: true,
          pos: state.pos === numItems - 1 ? 0 : state.pos + 1
        });
      case GOTO:
        return (0, _extends3.default)({}, state, {
          pos: pos
        });
      case 'stopSliding':
        return (0, _extends3.default)({}, state, {
          sliding: false
        });
      default:
        return state;
    }
  };

  var goTo = function goTo(dir) {
    console.log(dir);
    slide(dir);
  };

  var _useReducer = (0, _react.useReducer)(reducer, initialState),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var dir = state.dir,
      sliding = state.sliding,
      pos = state.pos;

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray3.default)(_useState3, 2),
      isSwiping = _useState4[0],
      setIsSwipingTo = _useState4[1];

  var handlers = (0, _reactSwipeable.useSwipeable)({
    onSwiping: function onSwiping(e) {
      setIsSwipingTo(true);
    },
    onSwiped: function onSwiped() {
      setTimeout(function () {
        setIsSwipingTo(false);
      }, 150);
    },
    onSwipedLeft: function onSwipedLeft() {
      goTo(NEXT);
    },
    onSwipedRight: function onSwipedRight() {
      goTo(PREV);
    },
    trackMouse: true
    //preventDefaultTouchmoveEvent: true,
  });

  var numItems = srcs.length;

  var arrayOfSecondaryRefs = (0, _from2.default)({ length: srcs.length }, function () {
    return (0, _react.useRef)(null);
  });
  var arrayOfPrimaryRefs = (0, _from2.default)({ length: srcs.length }, function () {
    return (0, _react.useRef)(null);
  });

  var externalSwipeableRef = (0, _react.useRef)(null);
  var mainImageRef = (0, _react.useRef)(null);

  var _useState5 = (0, _react.useState)(0),
      _useState6 = (0, _slicedToArray3.default)(_useState5, 2),
      previewImageWidth = _useState6[0],
      setPreviewImageWidthTo = _useState6[1];

  var _useState7 = (0, _react.useState)(0),
      _useState8 = (0, _slicedToArray3.default)(_useState7, 2),
      previewImageHeight = _useState8[0],
      setPreviewImageHeightTo = _useState8[1];

  var _useState9 = (0, _react.useState)(0),
      _useState10 = (0, _slicedToArray3.default)(_useState9, 2),
      previewImageFrameWidth = _useState10[0],
      setPreviewImageFrameWidthTo = _useState10[1];

  var _useState11 = (0, _react.useState)(0),
      _useState12 = (0, _slicedToArray3.default)(_useState11, 2),
      previewImageFrameHeight = _useState12[0],
      setPreviewImageFrameHeightTo = _useState12[1];

  var _useState13 = (0, _react.useState)(0),
      _useState14 = (0, _slicedToArray3.default)(_useState13, 2),
      mainImageWidth = _useState14[0],
      setMainImageWidthTo = _useState14[1];

  var _useState15 = (0, _react.useState)(0),
      _useState16 = (0, _slicedToArray3.default)(_useState15, 2),
      mainImageMaxHeight = _useState16[0],
      setMainImageMaxHeightTo = _useState16[1];

  (0, _react.useEffect)(function () {
    var previewImageElement = arrayOfSecondaryRefs[pos] && arrayOfSecondaryRefs[pos].current;

    if (previewImageElement) {
      var previewImageBCR = previewImageElement.getBoundingClientRect();
      setPreviewImageWidthTo(previewImageBCR.width);
      setPreviewImageHeightTo(previewImageBCR.height);

      if (externalSwipeableRef) {
        var previewFrameBCR = externalSwipeableRef.current.getBoundingClientRect();
        setPreviewImageFrameWidthTo(previewFrameBCR.width);
        setPreviewImageFrameHeightTo(previewFrameBCR.height);
      }

      externalSwipeableRef.current.scrollTo({
        left: previewImageWidth * (pos + 0.5) - previewImageFrameWidth / 2,
        top: previewImageHeight * (pos + 0.5) - previewImageFrameHeight / 2,
        behavior: 'smooth'
      });
    }
  }, [pos]);

  var _useState17 = (0, _react.useState)(0),
      _useState18 = (0, _slicedToArray3.default)(_useState17, 2),
      forced = _useState18[0],
      forceUpdate = _useState18[1];

  (0, _react.useEffect)(function () {
    setTimeout(function () {
      return forceUpdate(1);
    }, 200);
  }, []);

  (0, _react.useEffect)(function () {
    debug && console.log(arrayOfPrimaryRefs[0].current && arrayOfPrimaryRefs[0].current.offsetHeight);
    var mainImageElement = arrayOfPrimaryRefs[pos] && arrayOfPrimaryRefs[pos].current;
    if (mainImageElement) {
      setMainImageWidthTo(mainImageElement.getBoundingClientRect().width);
      setMainImageMaxHeightTo(Math.max.apply(Math, (0, _toConsumableArray3.default)(arrayOfPrimaryRefs.map(function (primaryRef) {
        return primaryRef.current.getBoundingClientRect().height;
      }))));

      if (sliding) {
        var by = (mainImageWidth + imageMargin) * pos;

        mainImageRef.current.scrollTo({
          left: by,
          behavior: 'smooth'
        });
      } else {
        var _by = (mainImageWidth + imageMargin) * pos;

        mainImageRef.current.scrollTo({
          left: _by
        });
      }
    }
  }, [pos, forced]);

  var getOptionProps = function getOptionProps(src, i) {
    return function () {
      var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var className = _ref12.className,
          style = _ref12.style,
          _onClick = _ref12.onClick,
          props = (0, _objectWithoutProperties3.default)(_ref12, ['className', 'style', 'onClick']);

      return (0, _extends3.default)({
        style: (0, _extends3.default)({
          backgroundImage: 'url(\'' + src + '\')'
        }, style),
        key: i,
        onClick: function onClick(e) {
          for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }

          _onClick && _onClick.apply(undefined, [e].concat(args));
          dispatch({ type: GOTO, pos: i });
        },

        id: 'imageviewer__preview__item-' + i,
        className: className ? (0, _helperFunctions.flippyClass)(pos === i, 'imageviewer__preview__item', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(pos === i, className, 'active', 'inactive') : (0, _helperFunctions.flippyClass)(pos === i, 'imageviewer__preview__item', 'active', 'inactive')
      }, props);
    };
  };
  var renderDebugArea = function renderDebugArea() {
    return _react2.default.createElement(
      'div',
      { style: { background: '#fff' } },
      (0, _stringify2.default)(state),
      ' isComponentActive: ',
      (0, _stringify2.default)(isComponentActive)
    );
  };

  var _useOutsideClickListe = (0, _OutsideClickListener.useOutsideClickListener)({
    outsideHandler: function outsideHandler() {
      return setIsComponentActive(false);
    },
    insideHandler: function insideHandler() {
      return setIsComponentActive(true);
    }
  }),
      elClickListenerRef = _useOutsideClickListe.elClickListenerRef;

  (0, _KBListener.useKBListener)({
    keyCodes: [[37, function () {
      if (isComponentActive) {
        slide(PREV);
      }
    }], [39, function () {
      if (isComponentActive) {
        slide(NEXT);
      }
    }]]
  });

  var sharedButtonProps = {
    layout: layout,
    disableDiscreteNavButtons: disableDiscreteNavButtons,
    previewImageHeight: previewImageHeight,
    mainImageMaxHeight: mainImageMaxHeight,
    previewImageWidth: previewImageWidth,
    mainImageWidth: mainImageWidth,
    srcsLength: srcs.length
  };

  var renderImageZoom = function renderImageZoom(src) {
    return _react2.default.createElement(_reactMediumImageZoom2.default, {
      shouldHandleZoom: function shouldHandleZoom(e) {
        return !isSwiping;
      },
      image: (0, _extends3.default)({
        src: src,
        className: cssImageUnzoomedClass
      }, unzoomedImageProps),
      zoomImage: (0, _extends3.default)({
        src: src,
        className: cssImageZoomedInClass
      }, zoomedInImageProps)
    });
  };

  var renderLargeNavButton = function renderLargeNavButton(dir) {
    var cardinalDir = dir === NEXT ? 'Right' : 'Left';
    return _react2.default.createElement(
      LargeNavButton,
      (0, _extends3.default)({}, sharedButtonProps, {
        dir: dir,
        onClick: function onClick() {
          return goTo(dir);
        },
        className: 'imageviewer__topnav imageviewer__topnav__' + dir,
        colors: _defaultStyles.buttonStyles.semiTransparentNeutral
      }),
      _react2.default.createElement(_SVGDir2.default, { size: 30, fill: '#666666', dir: cardinalDir })
    );
  };

  var renderSmallNavButton = function renderSmallNavButton(dir) {
    var cardinalDir = dir === NEXT ? 'Right' : 'Left';
    return _react2.default.createElement(
      SmallNavButton,
      (0, _extends3.default)({}, sharedButtonProps, {
        onClick: function onClick() {
          return goTo(dir);
        },
        className: 'imageviewer__bottomnav imageviewer__bottomnav__' + dir,
        colors: _defaultStyles.buttonStyles.semiTransparentNeutral
      }),
      _react2.default.createElement(_SVGDir2.default, { size: '24', fill: '#666666', dir: cardinalDir })
    );
  };

  return _react2.default.createElement(
    Container,
    {
      layout: layout,
      onClick: onClick,
      className: (0, _helperFunctions.flippyMultiBase)(isComponentActive, [className, 'imageviewer__container'], 'active', 'inactive'),
      ref: elClickListenerRef,
      style: style
    },
    _react2.default.createElement(
      MainFrame,
      {},
      renderLargeNavButton(PREV),
      _react2.default.createElement(
        MainImageFrame,
        (0, _extends3.default)({}, handlers, {

          ref: mainImageRef,
          width: mainImageWidth
        }),
        srcs.map(function (src, i) {
          return _react2.default.createElement(
            MainImage,
            {
              ref: arrayOfPrimaryRefs[i],
              key: i,
              imageMargin: imageMargin
            },
            renderImageZoom(src)
          );
        })
      ),
      renderLargeNavButton(NEXT)
    ),
    renderMidArea && renderMidArea(),
    debug && renderDebugArea(),
    renderOptions ? renderOptions({ getOptionProps: getOptionProps, srcs: srcs, pos: pos, externalSwipeableRef: externalSwipeableRef }) : _react2.default.createElement(
      PreviewFrame,
      { layout: layout },
      renderSmallNavButton(PREV),
      _react2.default.createElement(
        _Accordion2.default,
        {
          externalSwipeableRef: externalSwipeableRef
        },
        function (_ref13) {
          var handlers = _ref13.handlers,
              swipeableRef = _ref13.swipeableRef;
          return _react2.default.createElement(
            PreviewAccordion,
            (0, _extends3.default)({
              layout: layout,
              previewImageWidth: previewImageWidth,
              mainImageWidth: mainImageWidth,
              previewImageHeight: previewImageHeight,
              mainImageMaxHeight: mainImageMaxHeight,
              srcsLength: srcs.length
            }, handlers, {
              ref: swipeableRef
            }, accordionProps),
            srcs.map(function (src, i) {
              return renderOption ? renderOption({
                getOptionProps: getOptionProps(src, i),
                isActive: pos === i,
                containerRef: arrayOfSecondaryRefs[i]
              }) : _react2.default.createElement(PreviewButton, (0, _extends3.default)({
                isOn: pos === i,
                colors: 'darken',
                containerRef: arrayOfSecondaryRefs[i]
              }, getOptionProps(src, i)()));
            })
          );
        }
      ),
      renderSmallNavButton(NEXT)
    )
  );
};

exports.default = _react2.default.memo(ImageViewer);