'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMany = exports.SC = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n    justify-content: space-between;\n  '], ['\n    justify-content: space-between;\n  ']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n    display: flex;\n    flex-wrap: wrap;\n  '], ['\n    display: flex;\n    flex-wrap: wrap;\n  ']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n    display: flex;\n  '], ['\n    display: flex;\n  ']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n    padding: 0.5rem 0.75rem;\n  '], ['\n    padding: 0.5rem 0.75rem;\n  ']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(['\n    display: flex;\n    background: #f3f3f3;\n    border-radius: 0.25rem;\n    margin: 0.25rem 0.375rem;\n  '], ['\n    display: flex;\n    background: #f3f3f3;\n    border-radius: 0.25rem;\n    margin: 0.25rem 0.375rem;\n  ']),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(['\n    display: flex;\n    align-items: center;\n    color: #2b2b2b;\n    padding: 0.25rem 0.5rem;\n  '], ['\n    display: flex;\n    align-items: center;\n    color: #2b2b2b;\n    padding: 0.25rem 0.5rem;\n  ']),
    _templateObject7 = (0, _taggedTemplateLiteral3.default)(['\n    display: flex;\n    border-radius: 0.25rem;\n    margin: 0.25rem 0.375rem;\n  '], ['\n    display: flex;\n    border-radius: 0.25rem;\n    margin: 0.25rem 0.375rem;\n  ']);
//import { Button } from './Button'


var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _defaultStyles = require('./defaultStyles');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SC = exports.SC = {
  DropdownTrigger: (0, _styledComponents2.default)(_Button.StyledButton)(_templateObject),
  TriggerOptions: (0, _styledComponents2.default)('div')(_templateObject2),
  TriggerControls: (0, _styledComponents2.default)('div')(_templateObject3),
  TriggerControlsCaret: (0, _styledComponents2.default)('div')(_templateObject4),
  TriggerOption: (0, _styledComponents2.default)('div')(_templateObject5),
  TriggerOptionLabel: (0, _styledComponents2.default)('div')(_templateObject6),
  EmptyGuide: (0, _styledComponents2.default)('div')(_templateObject7)
};

var SelectMany = function SelectMany(_ref) {
  var _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === undefined ? function (x) {
    return console.log(x);
  } : _ref$onChange,
      _ref$buttonType = _ref.buttonType,
      buttonType = _ref$buttonType === undefined ? 'select--default' : _ref$buttonType,
      _ref$renderCurrentOpt = _ref.renderCurrentOption,
      renderCurrentOption = _ref$renderCurrentOpt === undefined ? function (option) {
    return option.label;
  } : _ref$renderCurrentOpt,
      _ref$sortingFunction = _ref.sortingFunction,
      sortingFunction = _ref$sortingFunction === undefined ? function () {
    return 0;
  } : _ref$sortingFunction,
      _ref$showUnselectedOn = _ref.showUnselectedOnly,
      showUnselectedOnly = _ref$showUnselectedOn === undefined ? false : _ref$showUnselectedOn,
      children = _ref.children,
      renderTrigger = _ref.renderTrigger,
      _ref$initialOptions = _ref.initialOptions,
      initialOptions = _ref$initialOptions === undefined ? [] : _ref$initialOptions,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onChange', 'buttonType', 'renderCurrentOption', 'sortingFunction', 'showUnselectedOnly', 'children', 'renderTrigger', 'initialOptions']);

  function init(initialOptions) {
    return { currentOptions: initialOptions };
  }

  var reducer = function reducer(_ref2, action) {
    var currentOptions = _ref2.currentOptions;

    var updatedState = {};
    switch (action.type) {
      case 'add':
        if (sortingFunction) {
          updatedState = {
            currentOptions: [].concat((0, _toConsumableArray3.default)(currentOptions), [action.payload.option]).sort(sortingFunction)
          };
        } else {
          updatedState = {
            currentOptions: [].concat((0, _toConsumableArray3.default)(currentOptions), [action.payload.option])
          };
        }
        break;
      case 'remove':
        updatedState = {
          currentOptions: currentOptions.filter(function (currentOption) {
            return currentOption.value !== action.payload.option.value;
          })
        };
        break;
      case 'clear':
        updatedState = init(action.payload.options);
        break;
      default:
        throw new Error();
    }
    onChange(updatedState.currentOptions);
    return updatedState;
  };

  var _useReducer = (0, _react.useReducer)(reducer, initialOptions, init),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      currentOptions = _useReducer2[0].currentOptions,
      dispatch = _useReducer2[1];

  var renderClearSelection = function renderClearSelection() {
    return _react2.default.createElement(_Button2.default, {
      type: 'cancel',
      colors: _defaultStyles.buttonStyles.redden,
      onClick: function onClick(e) {
        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
        dispatch({ type: 'clear', payload: { options: [] } });
      }
    });
  };
  var renderRemoveCurrentOption = function renderRemoveCurrentOption(currentOption) {
    return _react2.default.createElement(_Button2.default, {
      className: 'selectmany__option__remove',
      type: 'cancel',
      colors: 'darkhighlight',
      onClick: function onClick(e) {
        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
        dispatch({
          type: 'remove',
          payload: { option: currentOption }
        });
      }
    });
  };

  var isActive = function isActive(option) {
    return currentOptions.some(function (currentOption) {
      return currentOption.value === option.value;
    });
  };

  var getChildProps = function getChildProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref3.className,
        style = _ref3.style,
        _onClick = _ref3.onClick,
        option = _ref3.option,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['className', 'style', 'onClick', 'option']);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
        if (isActive(option)) {
          dispatch({ type: 'remove', payload: { option: option } });
        } else {
          dispatch({ type: 'add', payload: { option: option } });
        }
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyMultiBase)(isActive(option), [className, 'selectmany__option'], 'active', 'inactive'),
      style: style
    }, props);
  };

  var handleRenderTrigger = function handleRenderTrigger(_ref4) {
    var isOn = _ref4.isOn,
        _getTriggerProps = _ref4.getTriggerProps;
    return renderTrigger ? renderTrigger({
      dispatch: dispatch,
      currentOptions: currentOptions,
      isOn: isOn,
      getTriggerProps: function getTriggerProps() {
        var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var className = _ref5.className,
            props = (0, _objectWithoutProperties3.default)(_ref5, ['className']);
        return _getTriggerProps((0, _extends3.default)({
          className: ['selectmany__trigger', className]
        }, props));
      }
    }) : _react2.default.createElement(
      _Button2.default,
      {
        type: 'caretdown',
        isOn: isOn
      },
      function (_ref6) {
        var getButtonProps = _ref6.getButtonProps,
            icon = _ref6.icon,
            commonProps = (0, _objectWithoutProperties3.default)(_ref6, ['getButtonProps', 'icon']);
        return _react2.default.createElement(
          SC.DropdownTrigger,
          (0, _extends3.default)({}, commonProps, getButtonProps((0, _extends3.default)({}, _getTriggerProps({
            className: 'selectmany__trigger'
          })))),
          _react2.default.createElement(
            SC.TriggerOptions,
            {
              className: 'selectmany__options'
            },
            currentOptions.length > 0 ? currentOptions.map(function (currentOption, i) {
              return _react2.default.createElement(
                SC.TriggerOption,
                {
                  key: '' + currentOption.value + i,
                  className: 'selectmany__option'
                },
                _react2.default.createElement(
                  SC.TriggerOptionLabel,
                  { className: 'selectmany__option__label' },
                  renderCurrentOption(currentOption)
                ),
                renderRemoveCurrentOption(currentOption)
              );
            }) : _react2.default.createElement(
              SC.EmptyGuide,
              {
                className: 'selectmany__guide'
              },
              'select one...'
            )
          ),
          _react2.default.createElement(
            SC.TriggerControls,
            { className: 'selectmany__removeall' },
            currentOptions.length > 0 && renderClearSelection(),
            _react2.default.createElement(
              SC.TriggerControlsCaret,
              {
                className: 'selectmany__caret'
              },
              icon
            )
          )
        );
      }
    );
  };
  return _react2.default.createElement(
    _CTCPopover2.default,
    (0, _extends3.default)({
      renderTrigger: handleRenderTrigger

    }, props),
    function (_ref7) {
      var getChildrenProps = _ref7.getChildrenProps,
          toggleIsOn = _ref7.toggleIsOn;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        getChildrenProps: getChildrenProps,
        toggleIsOn: toggleIsOn,
        currentOptions: currentOptions
      }) : _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getChildrenProps({ style: { zIndex: 1 } })),
        children.filter(function (option) {
          if (showUnselectedOnly) {
            if (!currentOptions.some(function (currentOption) {
              return currentOption.value === option.value;
            })) {
              return option;
            }
          } else {
            return option;
          }
        }).map(function (option) {
          return _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getChildProps({ option: option }), {
              colors: _defaultStyles.buttonStyles.monochrome,
              isOn: currentOptions.some(function (currentOption) {
                return currentOption.value === option.value;
              }),
              key: option.value
            }),
            option.label
          );
        })
      );
    }
  );
};

exports.SelectMany = SelectMany;
exports.default = SelectMany;